org.springframework.core.codec

## Class ResourceDecoder

- java.lang.Object
- - org.springframework.core.codec.AbstractDecoder<T>
  - - org.springframework.core.codec.AbstractDataBufferDecoder<Resource>
    - - org.springframework.core.codec.ResourceDecoder

- All Implemented Interfaces:
    Decoder<Resource>

      public class ResourceDecoder
      extends AbstractDataBufferDecoder<Resource>

  Decoder for `Resources`.
  Since:
    5.0
  Author:
    Arjen Poutsma, Rossen Stoyanchev

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `FILENAME_HINT` Name of hint with a filename for the resource(e.g.

    - ### Fields inherited from class org.springframework.core.codec.AbstractDecoder

      `logger`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ResourceDecoder()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canDecode(ResolvableType elementType, MimeType mimeType)` Whether the decoder supports the given target element type and the MIME type of the source stream.
    `Resource` | `decode(DataBuffer dataBuffer, ResolvableType elementType, MimeType mimeType, Map<String,Object> hints)` Decode a data buffer to an Object of type T.
    `reactor.core.publisher.Flux<Resource>` | `decode(Publisher<DataBuffer> inputStream, ResolvableType elementType, MimeType mimeType, Map<String,Object> hints)` Decode a `DataBuffer` input stream into a Flux of `T`.

    - ### Methods inherited from class org.springframework.core.codec.AbstractDataBufferDecoder

      `decodeDataBuffer, decodeToMono, getMaxInMemorySize, setMaxInMemorySize`

    - ### Methods inherited from class org.springframework.core.codec.AbstractDecoder

      `getDecodableMimeTypes, getLogger, setLogger`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.springframework.core.codec.Decoder

      `getDecodableMimeTypes`

- - ### Field Detail

    - #### FILENAME_HINT

          public static String FILENAME_HINT

      Name of hint with a filename for the resource(e.g. from "Content-Disposition" HTTP header).

  - ### Constructor Detail

    - #### ResourceDecoder

          public ResourceDecoder()

  - ### Method Detail

    - #### canDecode

          public boolean canDecode(ResolvableType elementType,
                                   @Nullable
                                   MimeType mimeType)

      Description copied from interface: `Decoder`
      Whether the decoder supports the given target element type and the MIME type of the source stream.
      Specified by:
        `canDecode` in interface `Decoder<Resource>`
      Overrides:
        `canDecode` in class `AbstractDecoder<Resource>`
      Parameters:
        `elementType` - the target element type for the output stream
        `mimeType` - the mime type associated with the stream to decode (can be `null` if not specified)
      Returns:
        `true` if supported, `false` otherwise

    - #### decode

          public reactor.core.publisher.Flux<Resource> decode(Publisher<DataBuffer> inputStream,
                                                              ResolvableType elementType,
                                                              @Nullable
                                                              MimeType mimeType,
                                                              @Nullable
                                                              Map<String,Object> hints)

      Description copied from interface: `Decoder`
      Decode a `DataBuffer` input stream into a Flux of `T`.
      Specified by:
        `decode` in interface `Decoder<Resource>`
      Overrides:
        `decode` in class `AbstractDataBufferDecoder<Resource>`
      Parameters:
        `inputStream` - the `DataBuffer` input stream to decode
        `elementType` - the expected type of elements in the output stream; this type must have been previously passed to the `Decoder.canDecode(org.springframework.core.ResolvableType, org.springframework.util.MimeType)` method and it must have returned `true`.
        `mimeType` - the MIME type associated with the input stream (optional)
        `hints` - additional information about how to do decode
      Returns:
        the output stream with decoded elements

    - #### decode

          public Resource decode(DataBuffer dataBuffer,
                                 ResolvableType elementType,
                                 @Nullable
                                 MimeType mimeType,
                                 @Nullable
                                 Map<String,Object> hints)

      Description copied from interface: `Decoder`
      Decode a data buffer to an Object of type T. This is useful for scenarios, that distinct messages (or events) are decoded and handled individually, in fully aggregated form.
      Parameters:
        `dataBuffer` - the `DataBuffer` to decode
        `elementType` - the expected output type
        `mimeType` - the MIME type associated with the data
        `hints` - additional information about how to do decode
      Returns:
        the decoded value, possibly `null`